// 萔ݒEevZs֐
unit UnitFunc ;

interface

uses
   SysUtils, WinProcs, Classes, Forms, Math ;

{萔̐ݒ}
   const
       _CR = #13#10 ;               {s}
       _LIMITN = 0.000000000000001 ;{El}

   procedure Delay(T: longint);   {s~bԑ҂}
{l֐}
	procedure SwapF(var V1,V2:double) ;
   function  Dround(V1,V2:double):double ;
   function GetAngle(x1,y1,x2,y2:double):double;
   function GetLength(x1,y1,x2,y2:double):double;
   function RevX(x,y,cx,cy,a:double):double ;
   function RevY(x,y,cx,cy,a:double):double ;
   procedure Revo(x1,y1,xc,yc,a:double;var x2,y2:double) ;
   procedure CrossPointToLine(x1,y1,x2,y2,px,py:double;var vx,vy:double);
   function  CrossPointToCircle(x1,y1,r1,px,py:double;var vx,vy:double):Boolean;
   function  CrossLineToLine(ax1,ay1,ax2,ay2,bx1,by1,bx2,by2:double;var vx,vy:double):Integer ;
   function  CrossLineToCircle(ax1,ay1,ax2,ay2,bx,by,br:double;var vx1,vy1,vx2,vy2:double):Integer ;
   function  CrossCircleToCircle(ax,ay,ar,bx,by,br:double;var vx1,vy1,vx2,vy2:double):Integer ;
   function  CheckOnLine(x1,y1,x2,y2,px,py:double):Boolean;
   function  CheckOnArc(x,y,a1,a2,px,py:double):Boolean;
{֐}
   function SInt(S:string) : Integer ;
   function SDbl(S:string) : Double ;
   function SUDbl(S:string;U:integer) : Double ;
   function KLength(S:String): Integer ;
   function Get1Char(S:String;V1:Integer): String ;
	function KTrim(S:String): String ;
{vf֘A֐}
   procedure GetTextPos(x,y,h,w,d,a:double;s:string;z1,z2:integer;var rx,ry:double) ;

implementation

{s~bԑ҂}
{@@in :T ... EGCg[~b]}
{@@out: --- }
{()ɎԂvł͂܂}
procedure Delay(T: longint);
var
   Finish: DWORD ;
begin
   Finish := GetTickCount + DWORD(T) ;
   repeat
       Application.ProcessMessages
   until GetTickCount > Finish
end;

// ========== ========== ========== ==========
//                  l ֐
// ========== ========== ========== ==========

{ ̂Qľ }
procedure SwapF(var V1,V2:double) ;
var
	w : double ;
begin
   w  := V1 ;
   V1 := V2 ;
   V2 := w ;
end;

{ ۂ߁iľܓj }
function Dround(V1,V2:double):double ;
begin
   if (V1 >= 0.0) then
      Result := Int(V1 / V2 + 0.5)*V2
   else
      Result := Int(V1 / V2 - 0.5)*V2
end;

// ̌Xpx[rad]vZ
//    ߂l 0 ` 2*Pi
function GetAngle(x1,y1,x2,y2:double):double;
var
   a : double ;
begin
   a := ArcTan2((y2-y1),(x2-x1));
   if (a < 0.0) then a := a + 2.0*Pi ;
   Result := a ;
end;

// ̒vZ
function GetLength(x1,y1,x2,y2:double):double;
begin
   Result := Sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)) ;
end;

{]ʑ x}
{  x,y:W}
{  cx,cy:]SW}
{  a:]px[rad]}
{  out : ]xW}
function RevX(x,y,cx,cy,a:double):double ;
begin
  Result := cx + (x-cx)*Cos(a) - (y-cy)*Sin(a) ;
end;

{]ʑ y}
{  x,y:W}
{  cx,cy:]SW}
{  a:]px[rad]}
{  out : ]yW}
function RevY(x,y,cx,cy,a:double):double ;
begin
  Result := cy + (x-cx)*Sin(a) + (y-cy)*Cos(a) ;
end;

{]ʑ x,y}
{  x1,y1:wW}
{  xc,yc:]SW}
{  a@@:]px[rad]}
{  x2,y2:]̍W}
procedure Revo(x1,y1,xc,yc,a:double;var x2,y2:double) ;
begin
  x2 := xc + (x1-xc)*Cos(a) - (y1-yc)*Sin(a) ;
  y2 := yc + (x1-xc)*Sin(a) + (y1-yc)*Cos(a) ;
end;

// _ɐɉ낵_i_j
//    Zo葱
// in)   x1,y1,x2,y2 : ẘJnEIW
// in)   px,py       : w_̔zuW
// out)  vx,vy       : _
procedure CrossPointToLine(x1,y1,x2,y2,px,py:double;var vx,vy:double);
var
   ang : double ;
begin
   ang := ArcTan2((y2-y1),(x2-x1));
   Revo(px,py,x1,y1,-ang,px,py);    // t]
   Revo(px,y1,x1,y1,ang,vx,vy);     // ]
end;

// _~ɐɉ낵_
//    Zo֐
// in)   x1,y1,r1 : w~̒S_WƔa
// in)   px,py    : w_̔zuW
// out)  (ret)    : True:~_L@False:_~S_Ɠ̂ŉ~_
// out)  vx,vy    : ~_
function  CrossPointToCircle(x1,y1,r1,px,py:double;var vx,vy:double):Boolean;
var
   ang : double ;
begin
   if (Abs(px-x1) < _LIMITN)and(Abs(py-y1) < _LIMITN) then begin
      Result := False ;
      vx := x1 ;
      vy := y1 ;
   end
   else begin
      Result := True ;
      ang := ArcTan2((py-y1),(px-x1));
      vx  := x1 + r1*Cos(ang);
      vy  := y1 + r1*Sin(ang);
   end;
end;

// Ɛ̌_Zo֐
// in)   ax1,ay1,ax2,ay2 : P̊JnEIW
// in)   bx1,by1,bx2,by2 : Q̊JnEIW
// out)  (ret) : 0:_@1:_L
// out)  vx,vy : _
function  CrossLineToLine(ax1,ay1,ax2,ay2,bx1,by1,bx2,by2:double;var vx,vy:double):Integer;
var
   a1,b1,c1 : double ;
   a2,b2,c2 : double ;
begin
   a1 := ay2-ay1;
   b1 := ax1-ax2;
   c1 := (ay2-ay1)*ax1+(ax1-ax2)*ay1;
   a2 := by2-by1;
   b2 := bx1-bx2;
   c2 := (by2-by1)*bx1+(bx1-bx2)*by1;

   Result := 0;
   if (Abs(a1) < _LIMITN)and(Abs(b1) < _LIMITN)
    or(Abs(a2) < _LIMITN)and(Abs(b2) < _LIMITN) then exit;  // Ȃ
   if (Abs(a1) < _LIMITN)and(Abs(a2) < _LIMITN)
    or(Abs(b1) < _LIMITN)and(Abs(b2) < _LIMITN) then exit ; // ꎲs
   if (Abs(a1*b2-a2*b1) < _LIMITN) then exit ;              // X
   Result := 1;
   if (Abs(a1) > _LIMITN) then begin
      vy:=(c2-a2*c1/a1)/(b2-a2*b1/a1);
      vx:=(c1-b1*vy)/a1;
   end
   else begin
      vy:=(c1-a1*c2/a2)/(b1-a1*b2/a2);
      vx:=(c2-b2*vy)/a2;
   end;
end;

// Ɖ~̌_Zo֐
// in)   ax1,ay1,ax2,ay2 : ̊JnEIW
// in)   bx,by,br        : ~̒S_WEa
// out)  (ret)    : 0:_@1:P_(ړ_)@2:Q_
// out)  vx1,vy1  : P_
// out)  vx2,vy2  : Q_
function  CrossLineToCircle(ax1,ay1,ax2,ay2,bx,by,br:double;var vx1,vy1,vx2,vy2:double):Integer ;
var
   ang : double ;
   bx1,by1,d : double ;
   xx1,xx2 : double ;
begin
   Result := 0 ;
   ang := ArcTan2((ay2-ay1),(ax2-ax1));   // ̌Xpx[rad]
   Revo(bx,by,ax1,ay1,-ang,bx1,by1);      // ~S_t]
   d := Abs(by1-ay1);                     // ~S_ƒ̋
   if ((d-br) > _LIMITN) then exit;       // _
   xx1 := bx1-sqrt(br*br-d*d);
   Revo(xx1,ay1,ax1,ay1,ang,vx1,vy1);     // ]
   if (Abs(d-br) <= _LIMITN) then begin
      Result := 1 ;
      vx2 := vx1 ;   // slɂȂƍ̂œWĂ
      vy2 := vy1 ;
   end
   else begin
      Result := 2 ;
      xx2 := bx1+sqrt(br*br-d*d);
      Revo(xx2,ay1,ax1,ay1,ang,vx2,vy2);  // ]
   end;
end;

// ~Ɖ~̌_Zo֐
// in)   ax,ay,ar : P~̒S_WEa
// in)   bx,by,br : Q~̒S_WEa
// out)  (ret)    : 0:_@1:P_(ړ_)@2:Q_
// out)  vx1,vy1  : P_
// out)  vx2,vy2  : Q_
function  CrossCircleToCircle(ax,ay,ar,bx,by,br:double;var vx1,vy1,vx2,vy2:double):Integer ;
var
   ang : double ;
   bx1,by1,d : double ;
   a,h : double ;
begin
   Result := 0 ;
   ang := ArcTan2((by-ay),(bx-ax));    // QS_Ԃ̌Xpx[rad]
   Revo(bx,by,ax,ay,-ang,bx1,by1);     // ~QS_t]
   d := Abs(bx1-ax);                   // QS_Ԃ̋
   if ((d-ar-br) > _LIMITN)
    or((Abs(ar-br)-d) > _LIMITN)
    or(Abs(d) < _LIMITN) then exit;    // _
   if (Abs(d-ar-br) <= _LIMITN)
    or(Abs(d-Abs(ar-br)) <= _LIMITN) then begin
      a := ar ;
      if (ar < br) then a := d-br ;
      Revo((ax+a),ay,ax,ay,ang,vx1,vy1);     // ]
      Result := 1 ;
      vx2 := vx1 ;   // slɂȂƍ̂œWĂ
      vy2 := vy1;
   end
   else begin
      Result := 2 ;
      a := (d*d+ar*ar-br*br)/2.0/d;
      h := Sqrt(ar*ar-a*a);
      Revo((ax+a),(ay+h),ax,ay,ang,vx1,vy1); // ]
      Revo((ax+a),(ay-h),ax,ay,ang,vx2,vy2); // ]
   end;
end;

// w肵_ɂ邩ǂmF
// (ret) True:  False:Ȃij
function  CheckOnLine(x1,y1,x2,y2,px,py:double):Boolean;
var
   a,x,x3 : double;
begin
   a := ArcTan2((y2-y1),(x2-x1));
   x := RevX(px,py,x1,y1,-a);
   x3:= RevX(x2,y2,x1,y1,-a);
   if (x > x1-_LIMITN)and(x < x3+_LIMITN) then
      Result := True
   else
      Result := False ;
end;

// w肵_~ʏɂ邩ǂmF
// (ret) True:  False:Ȃij
function  CheckOnArc(x,y,a1,a2,px,py:double):Boolean;
var
   a,aa,a3 : double;
begin
   a := GetAngle(x,y,px,py)*180.0/Pi;
   aa:= a - a1 ;
   if (a < 0.0) then aa := aa + 360.0 ;
   a3:= a2- a1 ;
   if (a3< 0.0) then a3 := a3 + 360.0 ;
   if (aa < (a3+_LIMITN))or(aa > (360.0-_LIMITN)) then
      Result := True
   else
      Result := False ;
end;

// ========== ========== ========== ==========
//                   ֐
// ========== ========== ========== ==========

// 𐮐lɕϊ
function SInt(S:string) : Integer ;
var
	i,j : Integer ;
begin
	if (S = '') then
   	i := 0
   else begin
      Val(S,i,j);
      if (j <> 0) then i := 0 ;
   end;
   Result := i ;
end;

// lɕϊ
function SDbl(S:string) : Double ;
var
	j : Integer ;
	w : Double ;
begin
	if (S = '') then
   	w := 0.0
   else begin
      Val(S,w,j);
      if (j <> 0) then w := 0.0 ;
   end;
   Result := w ;
end;

// APʂlāAl[mm]ɕϊ
//      0:mm 1:cm 2:m   3:km 4: 5:m 6:inch
// | 1    0.1  0.001 1e-6 1e+3 1e+6  25.4
//  7:in/ft/yd/rd/ch/fur/mi  8:////////
function SUDbl(S:string;U:integer) : Double ;
var
	i,j : Integer ;
	w,w1 : Double ;
   ss,s1,s2 : string ;
   fs : Boolean;
begin
  	w := 0.0;
   if (S <> '') then begin
      if (U < 7)or(U > 8) then begin
         Val(S,w,j);
         if (j <> 0) then w := 0.0 ;
         Case(U)of
         1: w := w * 10.0;
         2: w := w * 1000.0;
         3: w := w * 1000000.0;
         4: w := w * 0.001;
         5: w := w * 0.000001;
         6: w := w * 25.4;
         end;
      end
      else if (U = 7) then begin
         ss := AnsiLowerCase(KTrim(S));
         i:=1;
         fs:=False;
         s2:= '';
         w:=0.0;
         while(i <= Length(ss)) do begin
            s1 := ss[i];
            if (s1 = '-') then begin
               if (i = 1) then
                  fs := True;
            end
            else begin
               if (s1 >= '0')and(s1 <= '9')or(s1 = '.') then begin
                  s2 := s2 + s1 ;
               end
               else begin
                  w1 := 0.0;
                  if ((i+1)<=Length(ss)) then begin
                     Inc(i);
                     s1 := s1 + ss[i];
                     w1 := SDbl(s2);
                     if (s1 = 'in') then w1:=w1*25.4
                     else if (s1 = 'ft') then w1:=w1*25.4*12.0
                     else if (s1 = 'yd') then w1:=w1*914.4
                     else if (s1 = 'rd') then w1:=w1*914.4*5.5
                     else if (s1 = 'ch') then w1:=w1*914.4*22.0
                     else if (s1 = 'mi') then w1:=w1*914.4*1760.0
                     else if (s1 = 'fu')and((i+1)<=Length(ss)) then begin
                        if (ss[i+1] = 'r') then begin
                           Inc(i);
                           w1 := w1*914.4*22.0*10.0;
                        end;
                     end
                     else begin
                        w1 := 0.0;
                     end;
                  end;
                  w := w + w1 ;
                  s2 := '';
               end;
            end;
            Inc(i);
         end;
         if (fs) then w := -w ;
      end
      else if (U = 8) then begin
         ss := AnsiLowerCase(KTrim(S));
         i:=1;
         fs:=False;
         s2:= '';
         w:=0.0;
         while(i <= Length(ss)) do begin
            s1 := ss[i];
            if (s1 = '-') then begin
               if (i = 1) then
                  fs := True;
            end
            else begin
               if (s1 >= '0')and(s1 <= '9')or(s1 = '.') then begin
                  s2 := s2 + s1 ;
               end
               else begin
                  w1 := 0.0;
                  if ((i+1)<=Length(ss)) then begin
                     Inc(i);
                     s1 := s1 + ss[i];
                     w1 := SDbl(s2);
                     if      (s1 = '') then w1:=w1* 10000.0/33.0
                     else if (s1 = '') then w1:=w1*  1000.0/33.0
                     else if (s1 = '') then w1:=w1*   100.0/33.0
                     else if (s1 = '') then w1:=w1*    10.0/33.0
                     else if (s1 = '') then w1:=w1*     1.0/33.0
                     else if (s1 = '') then w1:=w1*100000.0/33.0
                     else if (s1 = '') then w1:=w1* 60000.0/33.0
                     else if (s1 = '') then w1:=w1* 60000.0*60.0/33.0
                     else if (s1 = '') then w1:=w1* 60000.0*60.0*36.0/33.0
                     else begin
                        w1 := 0.0;
                     end;
                  end;
                  w := w + w1 ;
                  s2 := '';
               end;
            end;
            Inc(i);
         end;
         if (fs) then w := -w ;
      end;
   end;
   Result := w ;
end;

// ̒ijԂ@oCgł͂Ȃ
function KLength(S:String): Integer ;
var
   i,j,i1:Integer ;
begin
   j := 0 ;
   i := 1 ;
   i1 := Length(S) ;
   while(i <= i1) do begin
      if (Ord(S[i]) >= 128)and(Ord(S[i]) <= 159)
       or(Ord(S[i]) >= 224)and(Ord(S[i]) <= 253) then
         Inc(i);
      Inc(i);
      Inc(j);
   end;
   Result := j ;
end;

// Po
//    V1 : ڂHi1`j
function Get1Char(S:String;V1:Integer): String ;
var
   ss : String ;
   i,j,i1:Integer ;
   f : Boolean ;
begin
   ss := '';
   j := 0 ;
   i := 1 ;
   i1 := Length(S) ;
   f := True ;
   while(f) do begin
      ss := S[i];
      if (Ord(S[i]) >= 128)and(Ord(S[i]) <= 159)
       or(Ord(S[i]) >= 224)and(Ord(S[i]) <= 253) then begin
         Inc(i);
         ss := ss + S[i] ;
      end;
      Inc(i);
      Inc(j);
      if (j = V1) then f := False else ss:='';
      if (i > i1) then f := False;
   end;
   Result := ss ;
end;

{󔒁iSpEpj菜}
function KTrim(S:String): String ;
var i,i1:Integer ;
	r,t : string ;
begin
	r := '' ;
	i := 1 ;
	i1 := Length(S) ;
	while(i <= i1) do begin
		if (Ord(S[i]) >= 128)and(Ord(S[i]) <= 159)
       or(Ord(S[i]) >= 224)and(Ord(S[i]) <= 253) then begin
      	// 
			t := S[i]+S[i+1] ;
			if (t <> '@') then r := r + t ;
			i := i + 2 ;
		end
      else begin
      	// ANK
			t := S[i] ;
			if (t <> ' ')and(Ord(S[i]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;

// ========== ========== ========== ==========
//              vf֘A ֐
// ========== ========== ========== ==========

// vf̈ʒu擾
// (in)  x,y : vff[^̈ʒu
// (in)  h,w,d,a : vff[^̍EEԊuEXpx[]
// (in)  s   : vff[^̓e
// (in)  z1  : vff[^̊_(0-8)
// (in)  z2  : 擾_(0-8)
// _F0:  1:  2:
//       3:  4:  5:
//       6:E  7:E  8:E
// (out) rx,ry : w肵_̍W
procedure GetTextPos(x,y,h,w,d,a:double;s:string;z1,z2:integer;var rx,ry:double) ;
var
   z : integer;   // w_
   l : double ;   // S
   a1: double ;   // px[rad]
   dx,dy:double;
begin
   z := z1 mod 100;
   if (z = z2) then begin
      rx := x ;
      ry := y ;
      exit ;
   end;
   l := Length(s)*w/2.0 + (KLength(s)-1)*d ;
   a1:= a*Pi/180.0 ;
   // _
   dx:= 0.0 ;  // 
   dy:= 0.0 ;
   Case (z) of
   1: begin    // 
         dx := 0.0 ;
         dy := h/2.0 ;
      end;
   2: begin    // 
         dx := 0.0 ;
         dy := h ;
      end;
   3: begin    // 
         dx := -l/2.0 ;
         dy :=  0.0 ;
      end;
   4: begin    // 
         dx := -l/2.0 ;
         dy :=  h/2.0 ;
      end;
   5: begin    // 
         dx := -l/2.0 ;
         dy :=  h ;
      end;
   6: begin    // E
         dx := -l ;
         dy :=  0.0 ;
      end;
   7: begin    // E
         dx := -l ;
         dy :=  h/2.0 ;
      end;
   8: begin    // E
         dx := -l ;
         dy :=  h ;
      end;
   end;
   // とw_
   Case (z2) of
   1: begin    // 
         dy := dy-h/2.0 ;
      end;
   2: begin    // 
         dy := dy-h ;
      end;
   3: begin    // 
         dx := dx+l/2.0 ;
      end;
   4: begin    // 
         dx := dx+l/2.0 ;
         dy := dy-h/2.0 ;
      end;
   5: begin    // 
         dx := dx+l/2.0 ;
         dy := dy-h ;
      end;
   6: begin    // E
         dx := dx+l ;
      end;
   7: begin    // E
         dx := dx+l ;
         dy := dy-h/2.0 ;
      end;
   8: begin    // E
         dx := dx+l ;
         dy := dy-h ;
      end;
   end;
   rx := x + dx*Cos(a1)-dy*Sin(a1) ;
   ry := y + dx*Sin(a1)+dy*Cos(a1) ;
end;

end.
